/*
 * Copyright (C) 1994, Jettero Heller
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* Gadget.h,v 1.5 1994/10/27 23:25:26 pgw Exp */

#if !defined(_GADGET_H_)
#define _GADGET_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/RectObj.h>

class GadgetClass : public _RectObjClass {
 protected:
   GadgetClass() {} /* only a derived class can make this */
 public:
   /* callbacks */
   void helpCallback(XtCallbackProc funcp, XtPointer data = NULL);

   /* resources */
   Pixel bottomShadowColor();
   Pixel highlightColor();
   void highlightOnEnter(Boolean);
   Boolean highlightOnEnter();
   void highlightThickness(Dimension);
   Dimension highlightThickness();
   void navigationType(XmNavigationType);
   XmNavigationType navigationType();
   void shadowThickness(Dimension);
   Dimension shadowThickness();
   Pixel topShadowColor();
   void traversalOn(Boolean on); 
   Boolean traversalOn();
   void unitType(unsigned char);
   unsigned char unitType();
   void userData(XtPointer udata);
   XtPointer userData();
};

#endif
