/*
 * Copyright (C) 1994, Jettero Heller
 *
 * You may distribute under the terms of the GNU Library General Public 
 * License as specified in the COPYING file that comes with the Xarm library.
 *
 */
/* Core.C,v 1.2 1994/10/27 23:26:25 pgw Exp */

/* Include(s): */
#include <Xarm/Core.h>

   /* resources */
void 
CoreClass::accelerators(XtAccelerators acc)
{
   XtVaSetValues(widget(),XmNaccelerators, acc, NULL);
}

XtAccelerators 
CoreClass::accelerators()
{
   XtAccelerators acc;
   XtVaGetValues(widget(),XmNaccelerators, &acc, NULL);
   return acc;
}

void 
CoreClass::background(Pixel p)
{
   XtVaSetValues(widget(),XmNbackground, p, NULL);
}

Pixel 
CoreClass::background()
{
   Pixel p;
   XtVaGetValues(widget(),XmNbackground, &p, NULL);
   return p;
}

void 
CoreClass::backgroundPixmap(Pixmap p)
{
   XtVaSetValues(widget(),XmNbackgroundPixmap, p, NULL);
}

Pixmap 
CoreClass::backgroundPixmap()
{
   Pixmap p;
   XtVaGetValues(widget(),XmNbackgroundPixmap, &p, NULL);
   return p;
}

void 
CoreClass::borderColor(Pixel p)
{
   XtVaSetValues(widget(),XmNborderColor, p, NULL);
}

Pixel 
CoreClass::borderColor()
{
   Pixel p;
   XtVaGetValues(widget(),XmNborderColor, &p, NULL);
   return p;
}

void 
CoreClass::borderPixmap(Pixmap p)
{
   XtVaSetValues(widget(),XmNborderPixmap, p, NULL);
}

Pixmap 
CoreClass::borderPixmap()
{
   Pixmap p;
   XtVaGetValues(widget(),XmNborderPixmap, &p, NULL);
   return p;
}

Colormap 
CoreClass::colormap()
{
   Colormap c;
   XtVaGetValues(widget(),XmNcolormap, &c, NULL);
   return c;
}

int 
CoreClass::depth()
{
   int d;
   XtVaGetValues(widget(),XmNdepth, &d, NULL);
   return d;
}

Boolean 
CoreClass::mappedWhenManaged()
{
   Boolean b;
   XtVaGetValues(widget(),XmNmappedWhenManaged, &b, NULL);
   return b;
}

void 
CoreClass::mappedWhenManaged(Boolean b)
{
   XtVaSetValues(widget(),XmNmappedWhenManaged, b, NULL);
}

Screen *
CoreClass::screen()
{
   Screen *s;
   XtVaGetValues(widget(),XmNscreen, &s, NULL);
   return s;
}

XtTranslations 
CoreClass::translations()
{
   XtTranslations t;
   XtVaGetValues(widget(),XmNtranslations, &t, NULL);
   return t;
}

void 
CoreClass::translations(XtTranslations t)
{
   XtVaSetValues(widget(),XmNtranslations, t, NULL);
}

